var NotificationManager = Proto.extend({

    constructor: function (notifications,targetId) {
        this.targetId = targetId;
        
        for(var i = notifications.length-1; i >= 1 ; --i)
            this.fireNotification(false, notifications[i]);

        if(notifications.length > 0)
            this.fireNotification(true, notifications[0]);

    },

    clearNotifications: function(){
        $(this.targetId).empty();
    },

    setResultSet: function(results){
        if(results.length <= 0)
            return;
        var container = $('#lastResultContainer');
        container.empty();
        for(var i = 0; i < results.length; ++i)
            container.append(this.renderNotification(results[i],false));
        container.fadeIn();
    },

    renderNotification: function(notification, closeable){
        var result = notification.result;
        var creationTime = notification.creationTime;

        var li = $(document.createElement('li'));
        li.addClass("notification");
        li.click(function(){
            ShowStackOverflowDocument(JSON.stringify(notification)); 
        });

        var topRow = $(document.createElement('div'));
        topRow.addClass("row-fluid");
        
        var span8 = $(document.createElement('div'));
        span8.addClass("span8");
        

        var title = $(document.createElement('div'));
        title.text(result.title);
        title.addClass("notificationTitle");
        

        var span4 = $(document.createElement('div'));
        span4.addClass("span4");
        span4.addClass("rating");
        span4.attr("name","rating");
        
        
        var ratingSvg = Rating.new(span4,40,9,'#323a45','#14b9d6', result.score);
        ratingSvg.draw();
        var btnContainer = $(document.createElement('div'));
        btnContainer.addClass("pull-right");
        var closeBtn = $(document.createElement('button'));
        closeBtn.addClass("btn");
        closeBtn.addClass("close");
        closeBtn.addClass("closeBtn");
        closeBtn.text("x");
        if(closeable)
            closeBtn.click(function(event){
                event.stopPropagation();
                var url = result.url;
                var slideUp = function(){
                    li.remove();
                }

                var fadeOut = function(){
                    li.slideUp(200,slideUp);
                }

                $(this).parent().fadeTo(200,0.01,fadeOut);
                JavaDeleteNotification(url);
            });
        else{
            closeBtn.attr("disabled","");
            closeBtn.addClass("hiddenCloseBtn");
        }
        


        btnContainer.append(closeBtn);
        topRow.append(span8);
        span8.append(title);
        topRow.append(btnContainer);
        topRow.append(span4);
        

        var bottomRow = $(document.createElement('div'));
        bottomRow.addClass("row-fluid");
        bottomRow.addClass("notificationDate");

        var time = $(document.createElement('div'));
        time.text(this.getTimeStamp(creationTime));
        time.addClass("span12");

        bottomRow.append(time);


        var jsonObj = $(document.createElement('div'));
        jsonObj.attr('name','jsonObj');
        jsonObj.attr('style','display:none;');
        jsonObj.text(JSON.stringify(notification));

        
        li.append(topRow);
        li.append(bottomRow);
        li.append(jsonObj);

        return li;
    },


    fireNotification: function(animated,notification){
        var node = this.renderNotification(notification,true);
        if(animated){
            node.addClass("hidden");
            node.slideUp(0);
        }

        $(this.targetId).prepend(node);

        if(animated)
            node.slideDown(500);
    },
    
    getTimeStamp: function (millis) {
       var now = new Date(millis);
       return ((now.getDate()) + '/' + (now.getMonth()+1) + '/' + now.getFullYear() + " " + now.getHours() + ':'
                     + ((now.getMinutes() < 10) ? ("0" + now.getMinutes()) : (now.getMinutes())));
    }
});


 
 var notificationManager; 
 var animationDone = true;
 function onPageLoaded(){  
	var notifications = eval(JavaGetNotifications(false)); //[ {"creationTime" :1375482839559, "result": {"title":"A Title", "url" : "http://stackoverflow.com/questions/2026260/java-how-to-use-urlconnection-to-post-request-with-authorization", "score":0.98 }}];
    var results = eval(JavaGetNotifications(true));
    notificationManager = NotificationManager.new(notifications,"#container");
    notificationManager.setResultSet(results);
    
    //Result Set Icon
 //    var paper = new Raphael('lastResultsButton', 30, 30);
	// paper.path('M4.082,4.083v2.999h22.835V4.083H4.082zM4.082,20.306h22.835v-2.999H4.082V20.306zM4.082,13.694h22.835v-2.999H4.082V13.694zM4.082,26.917h22.835v-2.999H4.082V26.917z')//'M27.87,7.863L23.024,4.82l-7.889,12.566l4.842,3.04L27.87,7.863zM14.395,21.25l-0.107,2.855l2.527-1.337l2.349-1.24l-4.672-2.936L14.395,21.25zM29.163,3.239l-2.532-1.591c-0.638-0.401-1.479-0.208-1.882,0.43l-0.998,1.588l4.842,3.042l0.999-1.586C29.992,4.481,29.802,3.639,29.163,3.239zM25.198,27.062c0,0.275-0.225,0.5-0.5,0.5h-19c-0.276,0-0.5-0.225-0.5-0.5v-19c0-0.276,0.224-0.5,0.5-0.5h13.244l1.884-3H5.698c-1.93,0-3.5,1.57-3.5,3.5v19c0,1.93,1.57,3.5,3.5,3.5h19c1.93,0,3.5-1.57,3.5-3.5V11.097l-3,4.776V27.062z')
 //        .attr({fill: "#FFF", stroke: "none"});

    
    $( "#slider" ).slider()
        .on('slideStop',function(ev){            
            JavaSetSensitivity('set',$('#slider').data('slider').getValue());
        });
        
    var sliderValue = JavaSetSensitivity('get');
//    console.log("VAL " + sliderValue);
    $( "#slider" ).slider('setValue',sliderValue);

    $('#lastResultsLabel').click(function(){
        if(!animationDone)
            return;
        $('#lastResultsButton').click();
    });
    $('#lastResultsButton').click(function(){

        animationDone = false;
        var classes = $('#menu').attr('class');
        var angle = classes.indexOf('in') == -1? 180 : 0;
        $('#lastResultsButton').rotate({
            animateTo: angle,
            duration:500,
            callback: function(){
                animationDone = true;
            }
        });
    });
    $('body').keydown(function(event){
        if(!animationDone)
            return;
        var classes = $('#menu').attr('class');
        if(event.keyCode == 37 && classes.indexOf('in') != -1)
            $('#lastResultsButton').click();

        if(event.keyCode == 39 && classes.indexOf('in') == -1)
            $('#lastResultsButton').click();        
    });
}