var Rating = Proto.extend({

    constructor: function (target, radius, strokeWidth, centerColor, ratingColor, score) {
      this.targetId = target;
      this.centerColor = centerColor;
      this.ratingColor = ratingColor;
      this.radius = radius;
      this.score = score;
      this.strokeWidth = strokeWidth;
      this.center = this.radius+this.strokeWidth/2.0;

      
      this.scoreDiv = $(document.createElement('div'));
      this.scoreDiv.addClass("scoreDiv");
      this.scoreDiv.attr("style","display:none;");
//      this.scoreDiv.text(Math.round(score * 20)/2.0);
      this.scoreDiv.text(Math.round(score * 200)/2.0);
      this.scoreDiv.append('<sup>%</sup>');
      var div = document.createElement('div');
      $(div).width(radius*2+strokeWidth);
      // $(div).attr('style','margin:auto;');
      $(div).addClass("ratingContainer");
      
      $(div).append(this.scoreDiv);
      $(target).append(div);

      var that = this;
      this.r = Raphael(div, radius*2+strokeWidth, radius*2+strokeWidth);
      this.param = {stroke: "#fff", "stroke-width": strokeWidth};
      this.marksAttr = {fill:"#444", stroke: "none"};
      // Custom Attribute
      this.r.customAttributes.arc = function (value, total, R) {
        var center = that.center;
        var alpha = 360 / total * value;
        var a = (90 - alpha) * Math.PI / 180;
        var x = center + R * Math.cos(a);
        var y = center - R * Math.sin(a);
        var color = that.ratingColor;//"hsb(".concat(Math.round(R) / 200, ",", value / total, ", .75)"),
        var path;
            if (total == value) {
                path = [["M", center, center - R], ["A", R, R, 0, 1, 1, center-0.001, center - R]];
            } else {
                path = [["M", center, center - R], ["A", R, R, 0, +(alpha > 180), 1, x, y]];
            }
            return {path: path, stroke: color};
        };

    },

    drawMarks: function(R, total) {
      var out = this.r.set();
      for (var value = 0; value < total; value++) {
          var alpha = 360 / total * value;
          var a = (90 - alpha) * Math.PI / 180;
          var x = this.center + R * Math.cos(a);
          var y = this.center - R * Math.sin(a);
          out.push(this.r.circle(x, y, 1).attr(this.marksAttr));
      }
      return out;
    },


    draw: function(){      
      this.drawMarks(this.radius, 25);
      this.hand = this.r.path().attr(this.param).attr({arc: [0, 50, this.radius]});
      this.hand.animate({arc: [Math.round(this.score * 100), 100, this.radius]}, 900, ">");
      this.r.circle(this.center, this.center, this.radius-this.strokeWidth/2.0).attr(this.marksAttr);
      this.scoreDiv.fadeIn(1500);
      // this.r.text(this.radius, this.radius, Math.round(this.score * 20)/2.0);
    }


  });